// 4̃jbg2 (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	unsigned char id1[]="drive 1";
	int i,d;

	struct fpos md[] =
	{
		{ 0x16, 0x01, 0x1900 }, //
		{ 0x17, 0x0a, 0x0800 }, //
		{ 0x18, 0x02, 0x0400 }, //
		{ 0x18, 0x06, 0x0400 }, // 
		{ 0x18, 0x0a, 0x0200 }, // 
		{ 0x18, 0x0c, 0x0300 }, // 
		{ 0x18, 0x0f, 0x0600 }, //
		{ 0x19, 0x05, 0x0100 }, //
		{ 0x19, 0x06, 0x0100 }, //
		{ 0x19, 0x07, 0x0200 }, //
		{ 0x19, 0x09, 0x1800 }, //
		{ 0x1b, 0x01, 0x0400 }, // 
		{ 0x1b, 0x05, 0x0300 }, // 
		{ 0x1b, 0x08, 0x0700 }, // 
		{ 0x1b, 0x0f, 0x0d00 }, //
		{ 0x1c, 0x0b, 0x0700 }, //
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x12, 0x09, 0x00, 0x0b, 0x01, buff, 0x100);
		if (!memcmp(&buff[0xf0],id1,sizeof(id1)-1))
		{
			printf("Disk A F܂.\n");
			fcut("PROG",  0x04, 0x02, 0x00, 0x01, 0x01, 0x0000, 0x6000);
			fcut("VOICE", 0x02, 0x01, 0x00, 0x10, 0x01, 0x0000, 0x0100);
			for (i=0; md[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",i);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
			}
			continue;
		}
	}
	return 0;
}

